## azure 0.8.4

=== debian/changelog ===
azure (0.8.4-2mrtns1) precise; urgency=low

  * Precise build by Evil Martians

 -- Maxim Filatov <bregor@evilmartians.com>  Tue, 28 Oct 2014 16:54:15 +0300

azure (0.8.4-1) unstable; urgency=low

  * source package automatically created by stdeb 0.6.0+git

 -- Microsoft Corporation <ptvshelp@microsoft.com>  Tue, 28 Oct 2014 17:53:25 +0400
