=== debian/control ===
Source: azure
Maintainer: Microsoft Corporation <ptvshelp@microsoft.com>
Section: python
Priority: optional
Build-Depends: python-all (>= 2.6.6-3), debhelper (>= 7)
Standards-Version: 3.9.1

Package: python-azure
Architecture: all
Depends: ${misc:Depends}, ${python:Depends}
Description: Windows Azure client APIs
