## azure quantum-3.4.0

=== requirements.txt ===
azure-core>=1.30,<2.0
azure-identity>=1.17,<2.0
# TODO: recent versions break recordings. 
# More than one match for "https://mystorage.blob.core.windows.net/.../rawOutputData"
azure-storage-blob==12.20
msrest>=0.7.1,<1.0
numpy>=1.21.0
deprecated>=1.2.12,<2.0
Markdown>=3.4.1
python-markdown-math>=0.8
